/*******************************************************************************
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 *******************************************************************************/
package org.ow2.orchestra.console.GWTConsole.client.ListInstanceActivity;

import com.google.gwt.core.client.GWT;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.uibinder.client.UiTemplate;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DeckPanel;
import com.google.gwt.user.client.ui.FlowPanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Widget;
import org.ow2.orchestra.console.GWTConsole.client.Commons.celltable.ConsoleCellTable;
import org.ow2.orchestra.console.GWTConsole.client.Commons.celltable.ConsolePager;
import org.ow2.orchestra.console.GWTConsole.client.ListInstance.MInstance;
import org.ow2.orchestra.console.GWTConsole.client.ProcessDetails.ProcessCanvasViewer;

/**
 * This class is the view of the instance activities list.
 *
 * @author Jean-Yves Goubet
 */
public class VListInstanceActivity extends Composite implements VListInstanceActivityIF {

  @UiTemplate("VListInstanceActivity.ui.xml")
  interface MyUiBinder extends UiBinder<Widget, VListInstanceActivity> {
  }

  private static MyUiBinder uiBinder = GWT.create(MyUiBinder.class);

  @UiField
  ConsoleCellTable<MInstance> instanceTable;
  @UiField
  ConsoleCellTable<MInstanceActivity> instanceActivitiesTable;
  @UiField
  ConsolePager pager;

  @UiField
  protected HTML bpmnContent;
  @UiField
  protected ProcessCanvasViewer processCanvas;
  @UiField
  protected FlowPanel buttonsPanel;
  @UiField
  protected DeckPanel deckPanel;

  private PListInstanceActivity presenter;

  /**
   * The constructor of the class
   *
   * @author Jean-Yves Goubet
   */
  public VListInstanceActivity() {
    //
    this.initWidget(VListInstanceActivity.uiBinder.createAndBindUi(this));
  }

  /**
   * Getter of the instance activities grid
   *
   * @return listInstanceActivityGrid : the grid that contains the activities of
   *         an instance
   * @author Jean-Yves Goubet
   */
  public ConsoleCellTable<MInstance> getInstanceTable() {
    return this.instanceTable;
  }

  public ConsoleCellTable<MInstanceActivity> getInstanceActivitiesTable() {
    return this.instanceActivitiesTable;
  }

  public void setPresenter(final PListInstanceActivity presenter) {
    this.presenter = presenter;
  }

  public PListInstanceActivity getPresenter() {
    return this.presenter;
  }

  public ConsolePager getPager() {
    return this.pager;
  }

  public HTML getBpmnContent() {
    return bpmnContent;
  }

  public FlowPanel getButtonsPanel() {
    return buttonsPanel;
  }

  public DeckPanel getDeckPanel() {
    return deckPanel;
  }

  public ProcessCanvasViewer getProcessCanvas() {
    return processCanvas;
  }
}
