/*
 * Copyright (C) 2012 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 */

package org.ow2.orchestra.console.GWTConsole.client.simulation;

import com.google.gwt.core.client.GWT;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.SimpleLayoutPanel;
import com.google.gwt.user.client.ui.SplitLayoutPanel;
import com.google.gwt.user.client.ui.Widget;
import org.ow2.orchestra.console.ws.client.factories.ClientFactory;
import org.ow2.orchestra.console.ws.client.ui.ws.explorer.ProcessEndpointsExplorer;

/**
 * @author Loic Albertin
 */
public class VProcessSimulation extends Composite implements VProcessSimulationIF {

  private PProcessSimulation presenter;
  private ProcessEndpointsExplorer processEndpointsExplorer;

  interface VProcessSimulationUiBinder extends UiBinder<Widget, VProcessSimulation> {
  }

  private static VProcessSimulationUiBinder ourUiBinder = GWT.create(VProcessSimulationUiBinder.class);
  @UiField
  SplitLayoutPanel simulationSplitPanel;
  @UiField
  SimpleLayoutPanel processEndpointsExplorerContainer;
  @UiField
  SimpleLayoutPanel requestResponsePanelContainer;

  public VProcessSimulation() {
    initWidget(ourUiBinder.createAndBindUi(this));
    ClientFactory clientFactory = GWT.create(ClientFactory.class);
    processEndpointsExplorer = clientFactory.getProcessEndpointsExplorerClientFactory().getProcessEndpointsExplorer();
    processEndpointsExplorerContainer.add(processEndpointsExplorer);
    requestResponsePanelContainer.add(clientFactory.getRequestResponseClientFactory().getRequestResponsePanel());
  }

  public void setPresenter(PProcessSimulation presenter) {
    this.presenter = presenter;
  }

  public ProcessEndpointsExplorer getProcessEndpointsExplorer() {
    return processEndpointsExplorer;
  }
}